package info.hostip.dao.mgr;

import java.util.Vector;
import java.sql.*;
import info.hostip.dao.core.*;

/******************SQL2JAVA_IMPORT_BEGIN******************/

/******************SQL2JAVA_IMPORT_END********************/


/** This is the dao class.
 * @author <a href="mailto:vinodpillai@excite.com">Vinod Pillai</a>
 */
public class CitybycountryManager extends Manager
/******************SQL2JAVA_EXTENDS_BEGIN******************/

/******************SQL2JAVA_EXTENDS_END********************/

{

/******************SQL2JAVA_CLASS_BEGIN******************/

/******************SQL2JAVA_CLASS_END********************/


	private static CitybycountryManager _global = new CitybycountryManager();
	public static CitybycountryManager getManager() { return _global; }

	public static final int CITY = 0;
	public static final int COUNTRY = 1;
	public static final int NAME = 2;
	public static final int LAT = 3;
	public static final int LNG = 4;
	public static final int STATE = 5;

	private static final String[] S2J_FIELD_NAMES = {
		"citybycountry.city",
		"citybycountry.country",
		"citybycountry.name",
		"citybycountry.lat",
		"citybycountry.lng",
		"citybycountry.state"
	};

	private static final String ALL_FIELDS = "citybycountry.city"
                            + ",citybycountry.country"
                            + ",citybycountry.name"
                            + ",citybycountry.lat"
                            + ",citybycountry.lng"
                            + ",citybycountry.state";

	public Citybycountry loadByKey(int _city) throws SQLException {
		Connection _conn = null;
		try {
			_conn = openConnection();
			Citybycountry _val = loadByKey(_city, _conn);
			closeConnection(_conn);
			return _val;
		}
		catch(SQLException e) {
			if(_conn != null)  try { closeConnection(_conn); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Citybycountry loadByKey(int _city, Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			_pstmt = _conn.prepareStatement("SELECT " + ALL_FIELDS + " FROM citybycountry WHERE citybycountry.city=?");
			_pstmt.setLong(1, _city);
			Citybycountry _list[] = loadByPreparedStatement(_pstmt);
			_pstmt.close();
			if(_list.length < 1) return null;
			else                 return _list[0];
		}
		catch(SQLException e) {
			if(_pstmt != null) try { _pstmt.close(); } catch(SQLException e2) { }
			throw e;
		}
	}

	public int deleteByKey(int _city) throws SQLException {
		Connection _conn = null;
		try {
			_conn = openConnection();
			int _rows = deleteByKey(_city, _conn);
			closeConnection(_conn);
			return _rows;
		}
		catch(SQLException e) {
			if(_conn!=null) try { closeConnection(_conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public int deleteByKey(int _city, Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			_pstmt = _conn.prepareStatement("DELETE from citybycountry WHERE citybycountry.city=?");
			_pstmt.setLong(1, _city);
			int _rows = _pstmt.executeUpdate();
			_pstmt.close();
			return _rows;
		}
		catch(SQLException e) {
			if(_pstmt!=null) try { _pstmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public Citybycountry[] loadAll() throws SQLException {
		Connection _conn = null;
		try {
			_conn = openConnection();
			Citybycountry _list[] = loadAll(_conn);
			closeConnection(_conn);
			return _list;
		}
		catch(SQLException e) {
			if(_conn != null)  try { closeConnection(_conn); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Citybycountry[] loadAll(Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			_pstmt = _conn.prepareStatement("SELECT " + ALL_FIELDS + " FROM citybycountry");
			Citybycountry _list[] = loadByPreparedStatement(_pstmt);
			_pstmt.close();
			return _list;
		}
		catch(SQLException e) {
			if(_pstmt != null) try { _pstmt.close(); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Citybycountry[] loadByPreparedStatement(PreparedStatement pstmt) throws SQLException {
		return loadByPreparedStatement(pstmt, null, 0);
	}

	public Citybycountry[] loadByPreparedStatement(PreparedStatement pstmt, int maxRows) throws SQLException {
		return loadByPreparedStatement(pstmt, null, maxRows);
	}

	public Citybycountry[] loadByPreparedStatement(PreparedStatement pstmt, int[] fieldList) throws SQLException {
		return loadByPreparedStatement(pstmt, fieldList, 0);
	}

	public Citybycountry[] loadByPreparedStatement(PreparedStatement pstmt, int[] fieldList, int maxRows) throws SQLException {
		ResultSet rs = null;
		try {
			rs = pstmt.executeQuery();
			java.util.Vector v = new java.util.Vector();
			while(rs.next() && (maxRows == 0 || v.size() < maxRows)) {
				if(fieldList == null) v.addElement(decodeRow(rs));
				else v.addElement(decodeRow(rs, fieldList));
			}
			rs.close();
			Citybycountry list[] = new Citybycountry[v.size()];
			v.copyInto(list);
			return list;
		}
		catch(SQLException e) {
			if(rs!=null) try { rs.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public Citybycountry[] loadByWhere(String where) throws SQLException {
		return loadByWhere(where, (int[])null, 0);
	}
	public Citybycountry[] loadByWhere(String where, int maxRows) throws SQLException {
		return loadByWhere(where, (int[])null, maxRows);
	}
	public Citybycountry[] loadByWhere(String where, int[] fieldList) throws SQLException {
		return loadByWhere(where, fieldList, 0);
	}
	public Citybycountry[] loadByWhere(String where, int[] fieldList, int maxRows) throws SQLException {
		Connection conn = null;
		try {
			conn = openConnection();
			Citybycountry _list[] = loadByWhere(where, conn, fieldList, maxRows);
			closeConnection(conn);
			return _list;
		}
		catch(SQLException e) {
			if(conn!=null) try { closeConnection(conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public Citybycountry[] loadByWhere(String where, Connection conn) throws SQLException {
		return loadByWhere(where, conn, null, 0);
	}

	public Citybycountry[] loadByWhere(String where, Connection conn, int[] fieldList) throws SQLException {
		return loadByWhere(where, conn, fieldList, 0);
	}

	public Citybycountry[] loadByWhere(String where, Connection conn, int[] fieldList, int maxRows) throws SQLException {
		String sql = null;
		if(fieldList == null) sql = "select " + ALL_FIELDS + " from citybycountry " + where;
		else {
			StringBuffer buff = new StringBuffer(128);
			buff.append("select ");
			for(int i = 0; i < fieldList.length; i++) {
				if(i != 0) buff.append(",");
				buff.append(S2J_FIELD_NAMES[fieldList[i]]);
			}
			buff.append(" from citybycountry ");
			buff.append(where);
			sql = buff.toString();
		}
		Statement stmt = null;
		ResultSet rs = null;
		try {
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql);
			java.util.Vector v = new java.util.Vector();
			while(rs.next() && (maxRows == 0 || v.size() < maxRows)) {
				if(fieldList == null) v.addElement(decodeRow(rs));
				else v.addElement(decodeRow(rs, fieldList));
			}
			rs.close();
			stmt.close();

			Citybycountry _list[] = new Citybycountry[v.size()];
			v.copyInto(_list);
			return _list;
		}
		catch(SQLException e) {
			if(rs!=null) try { rs.close();} catch(Exception e2) {}
			if(stmt!=null) try { stmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public void save(Citybycountry obj) throws SQLException {
		if(!obj.isModified()) return;
		Connection _conn = null;
		try {
			_conn = openConnection();
			save(obj, _conn);
			closeConnection(_conn);
		}
		catch(SQLException e) {
			if(_conn!=null) try { closeConnection(_conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public void save(Citybycountry obj, Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			if(obj.isNew()) {
				int _dirtyCount = 0;
				StringBuffer _sql = new StringBuffer("INSERT into citybycountry (");
				if(obj.isCityModified()) {  _sql.append("city").append(","); _dirtyCount++; }
				if(obj.isCountryModified()) {  _sql.append("country").append(","); _dirtyCount++; }
				if(obj.isNameModified()) {  _sql.append("name").append(","); _dirtyCount++; }
				if(obj.isLatModified()) {  _sql.append("lat").append(","); _dirtyCount++; }
				if(obj.isLngModified()) {  _sql.append("lng").append(","); _dirtyCount++; }
				if(obj.isStateModified()) {  _sql.append("state").append(","); _dirtyCount++; }
				_sql.setLength(_sql.length() - 1);
				_sql.append(") values (");
				for(int i = 0; i < _dirtyCount; i++) _sql.append("?,");
				_sql.setLength(_sql.length() - 1);
				_sql.append(")");

				_pstmt = _conn.prepareStatement(_sql.toString());
				_dirtyCount = 0;
				if(obj.isCityModified()) { _pstmt.setLong(++_dirtyCount, obj.getCity()); } 
				if(obj.isCountryModified()) { _pstmt.setLong(++_dirtyCount, obj.getCountry()); } 
				if(obj.isNameModified()) { _pstmt.setString(++_dirtyCount, obj.getName()); } 
				if(obj.isLatModified()) { _pstmt.setDouble(++_dirtyCount, obj.getLat()); } 
				if(obj.isLngModified()) { _pstmt.setDouble(++_dirtyCount, obj.getLng()); } 
				if(obj.isStateModified()) { _pstmt.setString(++_dirtyCount, obj.getState()); } 
				_pstmt.executeUpdate();
				obj.setIsNew(false);
				obj.resetIsModified();
			}
			else {
				StringBuffer _sql = new StringBuffer("UPDATE citybycountry SET ");
				if(obj.isCityModified()) {  _sql.append("city").append("=?,"); }
				if(obj.isCountryModified()) {  _sql.append("country").append("=?,"); }
				if(obj.isNameModified()) {  _sql.append("name").append("=?,"); }
				if(obj.isLatModified()) {  _sql.append("lat").append("=?,"); }
				if(obj.isLngModified()) {  _sql.append("lng").append("=?,"); }
				if(obj.isStateModified()) {  _sql.append("state").append("=?,"); }
				_sql.setLength(_sql.length() - 1);
				_sql.append(" WHERE ");
				_sql.append("citybycountry.city=?");
				_pstmt = _conn.prepareStatement(_sql.toString());
				int _dirtyCount = 0;
				if(obj.isCityModified()) { _pstmt.setLong(++_dirtyCount, obj.getCity()); } 
				if(obj.isCountryModified()) { _pstmt.setLong(++_dirtyCount, obj.getCountry()); } 
				if(obj.isNameModified()) { _pstmt.setString(++_dirtyCount, obj.getName()); } 
				if(obj.isLatModified()) { _pstmt.setDouble(++_dirtyCount, obj.getLat()); } 
				if(obj.isLngModified()) { _pstmt.setDouble(++_dirtyCount, obj.getLng()); } 
				if(obj.isStateModified()) { _pstmt.setString(++_dirtyCount, obj.getState()); } 
				_pstmt.setLong(++_dirtyCount, obj.getCity());
				_pstmt.executeUpdate();
				obj.resetIsModified();
			}
			_pstmt.close();
		}
		catch(SQLException e) {
			if(_pstmt!=null) try { _pstmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	private Citybycountry decodeRow(ResultSet rs) throws SQLException {
		Citybycountry obj = new Citybycountry();
		obj.setCity(rs.getInt(1));
		obj.setCountry(rs.getInt(2));
		obj.setName(rs.getString(3));
		obj.setLat(rs.getDouble(4));
		obj.setLng(rs.getDouble(5));
		obj.setState(rs.getString(6));
		obj.setIsNew(false);
		obj.resetIsModified();

		return obj;
	}

	private Citybycountry decodeRow(ResultSet rs, int[] fieldList) throws SQLException {
		Citybycountry obj = new Citybycountry();
		int pos = 0;
		for(int i = 0; i < fieldList.length; i++) {
			switch(fieldList[i]) {
				case CITY: obj.setCity(rs.getInt(++pos));
					break;
				case COUNTRY: obj.setCountry(rs.getInt(++pos));
					break;
				case NAME: obj.setName(rs.getString(++pos));
					break;
				case LAT: obj.setLat(rs.getDouble(++pos));
					break;
				case LNG: obj.setLng(rs.getDouble(++pos));
					break;
				case STATE: obj.setState(rs.getString(++pos));
					break;
			}
		}
		obj.setIsNew(false);
		obj.resetIsModified();

		return obj;
	}

}
